#!/usr/bin/env python
#
# Copyright 2009, Martin Owens.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# Change the gnome background to a random wallpaper from the list of wallpapers
#
import sys
sys.path.append('lib')

from config import config, target
from lister import get_lister
import os

backgrounds = get_lister('default', config)
wallpapers  = get_lister(str(config['type']), config)

filename = wallpapers.getRandom()

if filename and os.path.exists(filename):
    # This creates an entry for the backgrounds
    good_to_go = False
    for back in backgrounds.getItems(True):
        if unicode(back) == unicode(target):
            good_to_go = True
    if not good_to_go:
        print " ! Adding background '%s'" % target
        backgrounds.addNew(target, {
             u'name'       : u'random-background',
             u'scolor'     : u'#dadab0b08282',
             u'pcolor'     : u'#dadab0b08282',
             u'shade_type' : u'solid',
             u'options'    : u'stretched',
        })

    # Now replace the perminant file
    if os.path.lexists(target):
        os.remove(target)
    os.symlink(filename, target)

    # Clear up existing wallpaper as required
    if config['removeold'] and type not in ['gnome', 'folder']:
        oldfile = str(config['oldfile'])
        if oldfile and oldfile != filename and os.path.exists(oldfile):
            print " ! Deleting Old File %s" % oldfile
            os.remove(oldfile)

    # And finally save the new wallpaper as the old file.
    config['oldfile'] = filename
    config.save()
